﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace heohelper
{
    public class EnumCombobox : System.Windows.Forms.ComboBox
    {

        private Type _enum;

        public Type EnumType
        {
            get
            {
                return _enum;
            }
            set
            {
                _enum = value;
                if (value == null)
                    return;
                Helper.ObjectItem sel = this.SelectedItem as Helper.ObjectItem;

                this.Items.Clear();
                foreach (System.Enum r in Enum.GetValues(value))
                {
                    FriendlyNameAttribute fna = EnumHelper.GetAttributeOfType<FriendlyNameAttribute>(r);
                    string fn = "";
                    if (fna != null)
                        fn = fna.DisplayName;
                    else
                        fn = r.ToString();
                    Helper.ObjectItem oi = new Helper.ObjectItem(r, fn);
                    this.Items.Add(oi);
                    if (sel != null && r.Equals(sel.Value))
                    {
                        SelectedItem = oi;
                    }
                }

            }
        }

        public object SelectedEnumValue
        {
            get
            {
                Helper.ObjectItem sel = this.SelectedItem as Helper.ObjectItem;
                if (sel == null)
                    return null;
                return sel.Value;
            }
            set
            {
                foreach (object item in this.Items)
                {
                    Helper.ObjectItem sel = item as Helper.ObjectItem;
                    if (sel == null)
                        continue;
                    if(value.Equals(sel.Value))
                        SelectedItem = sel;
                }
            }
        }

    }
}
